/** TimerBeanInfo.java
* 
* Copyright (C) 1998  NetBeans, Inc.
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
*/

package com.netbeans.timerbean;

import java.beans.*;
import java.awt.Image;

/** The BeanInfo for the Timer bean.
*
* @version  1.00, Jul 20, 1998
*/
public class TimerBeanInfo extends SimpleBeanInfo {

  /** Icon for image data objects. */
  private Image icon;

  /** Array of property descriptors. */
  private static PropertyDescriptor[] desc;

  /** Array of event set descriptors. */
  private static EventSetDescriptor[] events;
  
  // initialization of the array of descriptors
  static {
    try {
      desc = new PropertyDescriptor[2];
      desc [0] = new PropertyDescriptor ("Delay", Timer.class, "getDelay", "setDelay");
      desc [1] = new PropertyDescriptor ("Once Only", Timer.class, "getOnceOnly", "setOnceOnly");

      events = new EventSetDescriptor [1];
      events[0] = new EventSetDescriptor (Timer.class, "timer", TimerListener.class, "onTime");
    } catch (IntrospectionException ex) {
      //throw new InternalError ();
      ex.printStackTrace ();
    }
  }

  public TimerBeanInfo () {
    icon = loadImage ("/com/netbeans/timerbean/timer.gif");
  }

  /** Provides the Timer's icon */
  public Image getIcon(int type) {
    return icon;
  }

  /** Descriptor of valid properties
  * @return array of properties
  */
  public PropertyDescriptor[] getPropertyDescriptors () {
    return desc;
  }
  
  /** Descriptor of valid events
  * @return array of event sets
  */
  public EventSetDescriptor[] getEventSetDescriptors () {
    return events;
  }
  
  public int getDefaultEventIndex () {
    return 0;
  }
  
}
